﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ThickTcpUiInWindow;

namespace FLY.Thick.Blowing.UI.Fix.Client
{
    /// <summary>
    /// Page_Menu.xaml 的交互逻辑
    /// </summary>
    public partial class Page_Menu : Page
    {
        TDGage gage;
        public Page_Menu()
        {
            InitializeComponent();
        }
        public void Init(TDGage gage) 
        {
            this.gage = gage;
            this.DataContext = this.gage;
        }

        private void button_custom_Click(object sender, RoutedEventArgs e)
        {
            Page_Custom p = new Page_Custom();
            p.Init(gage);
            NavigationService.Navigate(p);
        }



        private void button_curve_Click(object sender, RoutedEventArgs e)
        {
            Page_Curve p = new Page_Curve();
            p.Init(gage.mSysParam.ServerIPEP);
            NavigationService.Navigate(p);
        }



        private void button_warning_Click(object sender, RoutedEventArgs e)
        {
            Page_WarningSystem p = new Page_WarningSystem();
            p.Init(gage.mSysParam.ServerIPEP);
            NavigationService.Navigate(p);
        }

        private void button_flyad_Click(object sender, RoutedEventArgs e)
        {
            Page_FlyAD p = new Page_FlyAD();
            p.Init(gage.mSysParam.ServerIPEP, gage.mDynArea, gage.mTDGageService);

            NavigationService.Navigate(p);
        }

        private void button_passwork_Click(object sender, RoutedEventArgs e)
        {
            if (Window_Password.Authorize(1))
            {
                Window_PasswordEdit w = new Window_PasswordEdit();
                w.Init(gage.mSysParam.ServerIPEP);
                w.Owner = FLY.ControlLibrary.COMMON.GetWindow(this);
                if (w.ShowDialog()==true) 
                {
                    
                }
            }
        }

        private void button_version_Click(object sender, RoutedEventArgs e)
        {
            System.Diagnostics.Process.Start(@"版本说明.txt");
        }

        private void button_instruction_Click(object sender, RoutedEventArgs e)
        {
            System.Diagnostics.Process.Start(@"测厚仪说明书.pdf");
        }

        private void button_blowing_Click(object sender, RoutedEventArgs e)
        {
            Page_Blowing p = new Page_Blowing();
            p.Init(gage.mSysParam.ServerIPEP);
            NavigationService.Navigate(p);
        }
    }
}
