﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FLY.Thick.BulkDataModule;
using FLY.Thick.Base.Server.OBJProxy;
using FLY.Thick.Base.OBJ_INTERFACE;
using FLY.Thick.Blowing.Server.OBJProxy;

namespace FLY.Thick.BlowingScan.Server.OBJProxy
{
    public class OBJProxys
    {
        BulkDataService_OBJProxy mBulkDataOBJProxy;
        Initparam_OBJProxy mInitParamOBJProxy;
        BorderSearch_OBJProxy mBorderSearchOBJProxy;
        Curve_OBJProxy mCurveOBJProxy;
        DynArea_OBJProxy mDynAreaOBJProxy;
        GetSample_OBJProxy mGetSampleOBJProxy;
        ScanCorr_OBJProxy mScanCorrOBJProxy;
        FlyAD_OBJProxy mFlyADOBJProxy;
        FLY.Thick.RemoteHistory.RemoteHistory_OBJProxy mRemoteHistoryOBJProxy;
        GageInfo_OBJProxy mGageInfoOBJProxy;
        Fix_OBJProxy mFixOBJProxy;
        Profile_OBJProxy mProfileOBJProxy;
        WarningSystem_OBJProxy mWarningOBJProxy;
        Password_OBJProxy mPasswordOBJProxy;
        TDGage_OBJProxy mTDGageOBJProxy;
        BlowingScan_OBJProxy mBlowingOBJProxy;
        BlowingDetect_OBJProxy mBDetectOBJProxy;
        public OBJProxys(int objsys_idx, TDGage gage)
        {
            TDGage mGage = gage;
            mBulkDataOBJProxy = new BulkDataService_OBJProxy(objsys_idx, mGage.mBulk);


            mProfileOBJProxy = new Profile_OBJProxy(objsys_idx, mGage.mProfile);

            mBorderSearchOBJProxy = new BorderSearch_OBJProxy(objsys_idx, mGage.mBorderSearch);

            
            mCurveOBJProxy = new Curve_OBJProxy(objsys_idx, mGage.mCurve);

            mDynAreaOBJProxy = new DynArea_OBJProxy(objsys_idx, mGage.mDynArea);

            mGetSampleOBJProxy = new GetSample_OBJProxy(objsys_idx, mGage.mGetSample);

            mInitParamOBJProxy = new Initparam_OBJProxy(objsys_idx, mGage.mInitParam);

            mScanCorrOBJProxy = new ScanCorr_OBJProxy(objsys_idx, mGage.mGMScanCorr);

            mFlyADOBJProxy = new FlyAD_OBJProxy(objsys_idx, mGage.mFlyAD);

            mRemoteHistoryOBJProxy = new FLY.Thick.RemoteHistory.RemoteHistory_OBJProxy(objsys_idx,
                OBJ_INTERFACE_ID.REMOTEHISTORY_ID, mGage.mHistory);

            mGageInfoOBJProxy = new GageInfo_OBJProxy(objsys_idx, mGage.mGMGageInfo);

            mFixOBJProxy = new Fix_OBJProxy(objsys_idx, mGage.mGMFix);

            mWarningOBJProxy = new WarningSystem_OBJProxy(objsys_idx, mGage.mWarning);
 
            mPasswordOBJProxy = new Password_OBJProxy(objsys_idx, mGage.mPassword);

            mTDGageOBJProxy = new TDGage_OBJProxy(objsys_idx, mGage);

            mBlowingOBJProxy = new BlowingScan_OBJProxy(objsys_idx, mGage.mGMRenZiJiaScan);
            mBDetectOBJProxy = new BlowingDetect_OBJProxy(objsys_idx, mGage.mGMRenZiJiaScan.mPDetect);
            mTDGageOBJProxy.CurrObjSys.Start_Conn_Server(
                mGage.mSysParam.LocalEP,
                mBulkDataOBJProxy.ID);
        }
    }
}
